////////////////////////////////////////////////////////////////////////
// sprite04.c
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Sprite.h"
#include "Background.h"

#define MAX_X 79

const char SpriteBuffer[SPRITE_WIDTH * SPRITE_HEIGHT] = {0};

void SetColor(unsigned char nColorIndex, unsigned char nPaletteIndex)
{
  __asm
    ld a, 4 (ix)
    ld b, 5 (ix)
    ld c, b
    call #0xBC32 ;SCR SET INK
    __endasm;
}

void SetPalette(const unsigned char *pPalette)
{
  unsigned char nColor = 0;

  for(nColor = 0; nColor < NUM_COLORS; nColor++)
    SetColor(nColor, pPalette[nColor]);
}

void PutSpriteMode0(unsigned char *pAddress, unsigned char nWidth, unsigned char nHeight, unsigned char *pSprite)
{
	__asm
		LD L, 4(IX) 
		LD H, 5(IX) 
		LD C, 6(IX) 
		LD B, 7(IX)            
		LD E, 8(IX) 
		LD D, 9(IX) 

		_loop_alto:
		   PUSH BC
		   LD B,C
		   PUSH HL
		_loop_ancho:
		   LD A,(DE)
		   LD (HL),A
		   INC DE
		   INC HL
		   DJNZ _loop_ancho
		   POP HL
		   LD A,H
		   ADD #0x08
		   LD H,A
		   SUB #0xC0
		   JP NC, _sig_linea
		   LD BC, #0xC050
		   ADD HL,BC
		_sig_linea:
		   POP BC
		   DJNZ _loop_alto
	__endasm;
}

void PutSpriteLinealTrans(unsigned char *pAddress, unsigned char *pSprite, unsigned int nBytes)
{
	__asm
		LD L, 4(IX) 
		LD H, 5(IX) 
		LD E, 6(IX) 
		LD D, 7(IX)            
		LD C, 8(IX) 
		LD B, 9(IX) 

_loop:
		LD A,(DE)
		CP #0
		JP Z, _notpaint
		LD (HL),A
_notpaint:
		INC DE
		INC HL
		DEC BC
		LD A, #0
		ADD A, B
		ADD A, C
		JP NZ, _loop
		__endasm;
}

////////////////////////////////////////////////////////////////////////
unsigned char char1,char2,char3,char4;

unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
		CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}
////////////////////////////////////////////////////////////////////////

void main()
{
	unsigned char nSprite = 0;
	int nX = 20;
	int nY = 100;
	char nXDir = 1;
	unsigned int nLastMoveTime = GetTime();
	int nAux = 0;
	
	//SCR_SET_MODE 0
	__asm
		ld a, #0
		call #0xBC0E
	__endasm;

	//SCR SET BORDER 0
  __asm
    ld b, #0 ;black
    ld c, b
    call #0xBC38
  __endasm;
  
  SetPalette(Palette);

	PutSpriteMode0((unsigned char *)0xC000, 80, 200, Background);
  
	while(1)
	{
		if(GetTime() - nLastMoveTime < 10)
			continue;

		nLastMoveTime = GetTime();

		//move
		nX += nXDir;
			
		if(nX <= 0)
		{
			nX = 0;
			nXDir = 1;
		}
	
		if(nX >= (MAX_X - SPRITE_WIDTH))
		{
			nX = MAX_X - SPRITE_WIDTH;
			nXDir = -1;
		}
	
		//copy background to sprite double buffer
		for(nAux = 0; nAux < SPRITE_HEIGHT; nAux++)
			memcpy(SpriteBuffer + nAux * SPRITE_WIDTH, Background + 80 * (nY + nAux) + nX, SPRITE_WIDTH);
		
		//paint sprite to double buffer with transparency
		PutSpriteLinealTrans(SpriteBuffer, Sprite, SPRITE_WIDTH * SPRITE_HEIGHT);

		//paint the result to screen
		PutSpriteMode0((unsigned char *)(0xC000 + ((nY / 8u) * 80u) + ((nY % 8u) * 2048u) + nX), SPRITE_WIDTH, SPRITE_HEIGHT, SpriteBuffer);
	}
}
////////////////////////////////////////////////////////////////////////